package com.gic.spark.filter;

import com.gic.spark.datasource.entity.DataSourceEntity;
import com.gic.spark.datasource.entity.DataSourceSharding;
import com.gic.spark.datasource.mysql.MysqlRddManager;
import com.gic.spark.entity.bean.TagCouponBean;
import com.gic.spark.entity.request.CouponRequest;
import com.gic.spark.entity.request.FilterRequest;
import com.gic.spark.util.AppEnvUtil;
import com.gic.spark.util.ConstantUtil;
import org.apache.spark.api.java.JavaRDD;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/4/29
 */
public class TagCouponFilter implements BaseTagFilter{

    private DataSourceSharding dataSourceSharding=new DataSourceSharding(AppEnvUtil.MARKETING_SHARDING, ConstantUtil.TAB_COUPON_LOG);
    private static TagCouponFilter instance;
    public static TagCouponFilter getInstance(){
        if(null==instance){
            instance=new TagCouponFilter();
        }
        return instance;
    }
    private TagCouponFilter(){}

    @Override
    public List<DataSourceEntity> necessarySourceList() {
        List<DataSourceEntity> result = new ArrayList();
        result.add(dataSourceSharding);
        return result;
    }

    @Override
    public JavaRDD<Integer> filterValidMember(Integer enterpriseId, FilterRequest request) {
        CouponRequest couponRequest=(CouponRequest)request;
        JavaRDD<TagCouponBean> couponBeanRDD= MysqlRddManager.getPojoFromDataset(dataSourceSharding.getDatasetByEnterpriseId(enterpriseId),TagCouponBean.class).javaRDD()
                                                            .filter(data->couponRequest.getCouponList().contains(data.getCoupon_id()));
        couponBeanRDD.mapPartitions(data->{
            Set<Integer>result=new HashSet();
            while (data.hasNext()){
                TagCouponBean couponBean=data.next();
                switch (couponRequest.getTagCode()){

                }
            }
            return result.iterator();
        });

        return null;
    }
}
